Overview | Package | Class | Tree | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.vecmath
Class Matrix3f

    java.lang.Object
      javax.vecmath.Matrix3f

All Implemented Interfaces:
  java.io.Serializable, java.lang.Cloneable

    public class Matrix3f

extends java.lang.Object
implements java.io.Serializable, java.lang.Cloneable

A single precision floating point 3 by 3 matrix.

Author:
  Kenji hiranabe
See Also:
  Serialized Form

Field Summary
`float` | `m00` The first element of the first row.
`float` | `m01` The second element of the first row.
`float` | `m02` third element of the first row.
`float` | `m10` The first element of the second row.
`float` | `m11` The second element of the second row.
`float` | `m12` The third element of the second row.
`float` | `m20` The first element of the third row.
`float` | `m21` The second element of the third row.
`float` | `m22` The third element of the third row.

Constructor Summary
`Matrix3f()` Constructs and initializes a Matrix3f to all zeros.
`Matrix3f(float[] v)` Constructs and initializes a Matrix3f from the specified 9 element array.
`Matrix3f(float m00, float m01, float m02, float m10, float m11, float m12, float m20, float m21, float m22)` Constructs and initializes a Matrix3f from the specified nine values.
`Matrix3f(Matrix3d m1)` Constructs a new matrix with the same values as the Matrix3d parameter.
`Matrix3f(Matrix3f m1)` Constructs a new matrix with the same values as the Matrix3f parameter.

Method Summary
`void` | `add(float scalar)` Adds a scalar to each component of this matrix.
`void` | `add(float scalar, Matrix3f m1)` Adds a scalar to each component of the matrix m1 and places the result into this.
`void` | `add(Matrix3f m1)` Sets the value of this matrix to sum of itself and matrix m1.
`void` | `add(Matrix3f m1, Matrix3f m2)` Sets the value of this matrix to the matrix sum of matrices m1 and m2.
`java.lang.Object` | `clone()`
`float` | `determinant()` Computes the determinant of this matrix.
`boolean` | `epsilonEquals(Matrix3f m1, double epsilon)` Returns true if the L-infinite distance between this matrix and matrix m1 is less than or equal to the epsilon parameter, otherwise returns false.
`boolean` | `equals(Matrix3f m1)` Returns true if all of the data members of Matrix3f m1 are equal to the corresponding data members in this Matrix3f.
`boolean` | `equals(java.lang.Object o1)` Returns true if the Object o1 is of type Matrix3f and all of the data members of t1 are equal to the corresponding data members in this Matrix3f.
`void` | `getColumn(int column, float[] v)` Copies the matrix values in the specified column into the array parameter.
`void` | `getColumn(int column, Vector3f v)` Copies the matrix values in the specified column into the vector parameter.
`float` | `getElement(int row, int column)` Retrieves the value at the specified row and column of this matrix.
`void` | `getRow(int row, float[] v)` Copies the matrix values in the specified row into the array parameter.
`void` | `getRow(int row, Vector3f v)` Copies the matrix values in the specified row into the vector parameter.
`float` | `getScale()` Performs an SVD normalization of this matrix to calculate and return the uniform scale factor.
`int` | `hashCode()` Returns a hash number based on the data values in this object.
`void` | `invert()` Sets the value of this matrix to its inverse.
`void` | `invert(Matrix3f m1)` Sets the value of this matrix to the matrix inverse of the passed matrix m1.
`boolean` | `isOrthogonal()` Verifies whether this matrix is Orthogonal .
`void` | `mul(float scalar)` Multiplies each element of this matrix by a scalar.
`void` | `mul(float scalar, Matrix3f m1)` Multiplies each element of matrix m1 by a scalar and places the result into this.
`void` | `mul(Matrix3f m1)` Sets the value of this matrix to the result of multiplying itself with matrix m1.
`void` | `mul(Matrix3f m1, Matrix3f m2)` Sets the value of this matrix to the result of multiplying the two argument matrices together.
`void` | `mulNormalize(Matrix3f m1)` Multiplies this matrix by matrix m1, does an SVD normalization of the result, and places the result back into this matrix this = SVDnorm(this*m1).
`void` | `mulNormalize(Matrix3f m1, Matrix3f m2)` Multiplies matrix m1 by matrix m2, does an SVD normalization of the result, and places the result into this matrix this = SVDnorm(m1*m2).
`void` | `mulTransposeBoth(Matrix3f m1, Matrix3f m2)` Multiplies the transpose of matrix m1 times the transpose of matrix m2, and places the result into this.
`void` | `mulTransposeLeft(Matrix3f m1, Matrix3f m2)` Multiplies the transpose of matrix m1 times matrix m2, and places the result into this.
`void` | `mulTransposeRight(Matrix3f m1, Matrix3f m2)` Multiplies matrix m1 times the transpose of matrix m2, and places the result into this.
`void` | `negate()` Negates the value of this matrix: this = -this.
`void` | `negate(Matrix3f m1)` Sets the value of this matrix equal to the negation of of the Matrix3f parameter.
`void` | `normalize()` Performs singular value decomposition normalization of this matrix.
`void` | `normalize(Matrix3f m1)` Perform singular value decomposition normalization of matrix m1 and place the normalized values into this.
`void` | `normalizeCP()` Perform cross product normalization of this matrix.
`void` | `normalizeCP(Matrix3f m1)` Perform cross product normalization of matrix m1 and place the normalized values into this.
`void` | `rotX(float angle)` Sets the value of this matrix to a rotation matrix about the x axis by the passed angle.
`void` | `rotY(float angle)` Sets the value of this matrix to a rotation matrix about the y axis by the passed angle.
`void` | `rotZ(float angle)` Sets the value of this matrix to a rotation matrix about the z axis by the passed angle.
`void` | `set(AxisAngle4d a1)` Sets the value of this matrix to the matrix conversion of the double precision axis and angle argument.
`void` | `set(AxisAngle4f a1)` Sets the value of this matrix to the matrix conversion of the single precision axis and angle argument.
`void` | `set(float scale)` Sets the value of this matrix to a scale matrix with the passed scale amount.
`void` | `set(float[] m)` Sets the values in this Matrix3f equal to the row-major array parameter (ie, the first four elements of the array will be copied into the first row of this matrix, etc.).
`void` | `set(Matrix3d m1)` Sets the value of this matrix to the float value of the Matrix3d argument.
`void` | `set(Matrix3f m1)` Sets the value of this matrix to the double value of the Matrix3f argument.
`void` | `set(Quat4d q1)` Sets the value of this matrix to the matrix conversion of the (double precision) quaternion argument.
`void` | `set(Quat4f q1)` Sets the value of this matrix to the matrix conversion of the (single precision) quaternion argument.
`void` | `setColumn(int column, float[] v)` Sets the specified column of this matrix3d to the four values provided.
`void` | `setColumn(int column, float x, float y, float z)` Sets the specified column of this matrix3d to the three values provided.
`void` | `setColumn(int column, Vector3f v)` Sets the specified column of this matrix3d to the vector provided.
`void` | `setElement(int row, int column, float value)` Sets the specified element of this matrix3d to the value provided.
`void` | `setIdentity()` Sets this Matrix3f to identity.
`void` | `setRow(int row, float[] v)` Sets the specified row of this matrix3d to the four values provided.
`void` | `setRow(int row, float x, float y, float z)` Sets the specified row of this matrix3d to the three values provided.
`void` | `setRow(int row, Vector3f v)` Sets the specified row of this matrix3d to the Vector provided.
`void` | `setScale(float scale)` Sets the scale component of the current matrix by factoring out the current scale (by doing an SVD) from the rotational component and multiplying by the new scale.
`void` | `setZero()` Sets this matrix to all zeros.
`void` | `sub(Matrix3f m1)` Sets the value of this matrix to the matrix difference of itself and matrix m1 (this = this - m1).
`void` | `sub(Matrix3f m1, Matrix3f m2)` Sets the value of this matrix to the matrix difference of matrices m1 and m2.
`java.lang.String` | `toString()` Returns a string that contains the values of this Matrix3f.
`void` | `transform(Tuple3f t)` Transform the vector vec using this Matrix3f and place the result back into vec.
`void` | `transform(Tuple3f t, Tuple3f result)` Transform the vector vec using this Matrix3f and place the result into vecOut.
`void` | `transpose()` Sets the value of this matrix to its transpose.
`void` | `transpose(Matrix3f m1)` Sets the value of this matrix to the transpose of the argument matrix

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### m00

    public float m00

  The first element of the first row.

### m01

    public float m01

  The second element of the first row.

### m02

    public float m02

  third element of the first row.

### m10

    public float m10

  The first element of the second row.

### m11

    public float m11

  The second element of the second row.

### m12

    public float m12

  The third element of the second row.

### m20

    public float m20

  The first element of the third row.

### m21

    public float m21

  The second element of the third row.

### m22

    public float m22

  The third element of the third row.

Constructor Detail

### Matrix3f

    public Matrix3f()

  Constructs and initializes a Matrix3f to all zeros.

### Matrix3f

    public Matrix3f(float[] v)

  Constructs and initializes a Matrix3f from the specified 9 element array. this.m00 =v[0], this.m01=v[1], etc.

  Parameters:
    `v` - the array of length 9 containing in order

### Matrix3f

    public Matrix3f(float m00,
                    float m01,
                    float m02,
                    float m10,
                    float m11,
                    float m12,
                    float m20,
                    float m21,
                    float m22)

  Constructs and initializes a Matrix3f from the specified nine values.

  Parameters:
    `m00` - the [0][0] element
    `m01` - the [0][1] element
    `m02` - the [0][2] element
    `m10` - the [1][0] element
    `m11` - the [1][1] element
    `m12` - the [1][2] element
    `m20` - the [2][0] element
    `m21` - the [2][1] element
    `m22` - the [2][2] element

### Matrix3f

    public Matrix3f(Matrix3d m1)

  Constructs a new matrix with the same values as the Matrix3d parameter.

  Parameters:
    `m1` - The source matrix.

### Matrix3f

    public Matrix3f(Matrix3f m1)

  Constructs a new matrix with the same values as the Matrix3f parameter.

  Parameters:
    `m1` - The source matrix.

Method Detail

### add

    public final void add(float scalar)

  Adds a scalar to each component of this matrix.

  Parameters:
    `scalar` - The scalar adder.

### add

    public final void add(float scalar,
                          Matrix3f m1)

  Adds a scalar to each component of the matrix m1 and places the result into this. Matrix m1 is not modified.

  Parameters:
    `scalar` - The scalar adder.

### add

    public final void add(Matrix3f m1)

  Sets the value of this matrix to sum of itself and matrix m1.

  Parameters:
    `m1` - the other matrix

### add

    public final void add(Matrix3f m1,
                          Matrix3f m2)

  Sets the value of this matrix to the matrix sum of matrices m1 and m2.

  Parameters:
    `m1` - the first matrix
    `m2` - the second matrix

### clone

    public java.lang.Object clone()

  Overrides:
    `clone` in class `java.lang.Object`

### determinant

    public final float determinant()

  Computes the determinant of this matrix.

  Returns:
    the determinant of the matrix

### epsilonEquals

    public boolean epsilonEquals(Matrix3f m1,
                                 double epsilon)

  Returns true if the L-infinite distance between this matrix and matrix m1 is less than or equal to the epsilon parameter, otherwise returns false. The L-infinite distance is equal to MAX[i=0,1,2,3 ; j=0,1,2,3 ; abs(this.m(i,j) - m1.m(i,j)]

  Parameters:
    `m1` - The matrix to be compared to this matrix
    `epsilon` - the threshold value

### equals

    public boolean equals(Matrix3f m1)

  Returns true if all of the data members of Matrix3f m1 are equal to the corresponding data members in this Matrix3f.

  Parameters:
    `m1` - The matrix with which the comparison is made.
  Returns:
    true or false

### equals

    public boolean equals(java.lang.Object o1)

  Returns true if the Object o1 is of type Matrix3f and all of the data members of t1 are equal to the corresponding data members in this Matrix3f.

  Overrides:
    `equals` in class `java.lang.Object`
  Parameters:
    `o1` - the object with which the comparison is made.

### getColumn

    public final void getColumn(int column,
                                float[] v)

  Copies the matrix values in the specified column into the array parameter.

  Parameters:
    `column` - the matrix column
    `v` - The array into which the matrix row values will be copied

### getColumn

    public final void getColumn(int column,
                                Vector3f v)

  Copies the matrix values in the specified column into the vector parameter.

  Parameters:
    `column` - the matrix column
    `v` - The vector into which the matrix row values will be copied

### getElement

    public final float getElement(int row,
                                  int column)

  Retrieves the value at the specified row and column of this matrix.

  Parameters:
    `row` - the row number to be retrieved (zero indexed)
    `column` - the column number to be retrieved (zero indexed)
  Returns:
    the value at the indexed element

### getRow

    public final void getRow(int row,
                             float[] v)

  Copies the matrix values in the specified row into the array parameter.

  Parameters:
    `row` - the matrix row
    `v` - The array into which the matrix row values will be copied

### getRow

    public final void getRow(int row,
                             Vector3f v)

  Copies the matrix values in the specified row into the vector parameter.

  Parameters:
    `row` - the matrix row
    `v` - The vector into which the matrix row values will be copied

### getScale

    public final float getScale()

  Performs an SVD normalization of this matrix to calculate and return the uniform scale factor. This matrix is not modified.

  Returns:
    the scale factor of this matrix

### hashCode

    public int hashCode()

  Returns a hash number based on the data values in this object. Two different Matrix3f objects with identical data values (ie, returns true for equals(Matrix3f) ) will return the same hash number. Two objects with different data members may return the same hash value, although this is not likely.

  Overrides:
    `hashCode` in class `java.lang.Object`
  Returns:
    the integer hash value

### invert

    public final void invert()

  Sets the value of this matrix to its inverse.

### invert

    public final void invert(Matrix3f m1)

  Sets the value of this matrix to the matrix inverse of the passed matrix m1.

  Parameters:
    `m1` - the matrix to be inverted

### isOrthogonal

    public final boolean isOrthogonal()

  Verifies whether this matrix is Orthogonal .

  Returns:
    true if this matrix is Orthogonal

### mul

    public final void mul(float scalar)

  Multiplies each element of this matrix by a scalar.

  Parameters:
    `scalar` - The scalar multiplier.

### mul

    public final void mul(float scalar,
                          Matrix3f m1)

  Multiplies each element of matrix m1 by a scalar and places the result into this. Matrix m1 is not modified.

  Parameters:
    `scalar` - The scalar multiplier.
    `m1` - The original matrix.

### mul

    public final void mul(Matrix3f m1)

  Sets the value of this matrix to the result of multiplying itself with matrix m1.

  Parameters:
    `m1` - the other matrix

### mul

    public final void mul(Matrix3f m1,
                          Matrix3f m2)

  Sets the value of this matrix to the result of multiplying the two argument matrices together.

  Parameters:
    `m1` - the first matrix
    `m2` - the second matrix

### mulNormalize

    public final void mulNormalize(Matrix3f m1)

  Multiplies this matrix by matrix m1, does an SVD normalization of the result, and places the result back into this matrix this = SVDnorm(this*m1).

  Parameters:
    `m1` - the matrix on the right hand side of the multiplication

### mulNormalize

    public final void mulNormalize(Matrix3f m1,
                                   Matrix3f m2)

  Multiplies matrix m1 by matrix m2, does an SVD normalization of the result, and places the result into this matrix this = SVDnorm(m1*m2).

  Parameters:
    `m1` - the matrix on the left hand side of the multiplication
    `m2` - the matrix on the right hand side of the multiplication

### mulTransposeBoth

    public final void mulTransposeBoth(Matrix3f m1,
                                       Matrix3f m2)

  Multiplies the transpose of matrix m1 times the transpose of matrix m2, and places the result into this.

  Parameters:
    `m1` - The matrix on the left hand side of the multiplication
    `m2` - The matrix on the right hand side of the multiplication

### mulTransposeLeft

    public final void mulTransposeLeft(Matrix3f m1,
                                       Matrix3f m2)

  Multiplies the transpose of matrix m1 times matrix m2, and places the result into this.

  Parameters:
    `m1` - The matrix on the left hand side of the multiplication
    `m2` - The matrix on the right hand side of the multiplication

### mulTransposeRight

    public final void mulTransposeRight(Matrix3f m1,
                                        Matrix3f m2)

  Multiplies matrix m1 times the transpose of matrix m2, and places the result into this.

  Parameters:
    `m1` - The matrix on the left hand side of the multiplication
    `m2` - The matrix on the right hand side of the multiplication

### negate

    public final void negate()

  Negates the value of this matrix: this = -this.

### negate

    public final void negate(Matrix3f m1)

  Sets the value of this matrix equal to the negation of of the Matrix3f parameter.

  Parameters:
    `m1` - The source matrix

### normalize

    public final void normalize()

  Performs singular value decomposition normalization of this matrix.

### normalize

    public final void normalize(Matrix3f m1)

  Perform singular value decomposition normalization of matrix m1 and place the normalized values into this.

  Parameters:
    `m1` - Provides the matrix values to be normalized

### normalizeCP

    public final void normalizeCP()

  Perform cross product normalization of this matrix.

### normalizeCP

    public final void normalizeCP(Matrix3f m1)

  Perform cross product normalization of matrix m1 and place the normalized values into this.

  Parameters:
    `m1` - Provides the matrix values to be normalized

### rotX

    public final void rotX(float angle)

  Sets the value of this matrix to a rotation matrix about the x axis by the passed angle.

  Parameters:
    `angle` - the angle to rotate about the X axis in radians

### rotY

    public final void rotY(float angle)

  Sets the value of this matrix to a rotation matrix about the y axis by the passed angle.

  Parameters:
    `angle` - the angle to rotate about the Y axis in radians

### rotZ

    public final void rotZ(float angle)

  Sets the value of this matrix to a rotation matrix about the z axis by the passed angle.

  Parameters:
    `angle` - the angle to rotate about the Z axis in radians

### set

    public final void set(AxisAngle4d a1)

  Sets the value of this matrix to the matrix conversion of the double precision axis and angle argument.

  Parameters:
    `a1` - the axis and angle to be converted

### set

    public final void set(AxisAngle4f a1)

  Sets the value of this matrix to the matrix conversion of the single precision axis and angle argument.

  Parameters:
    `a1` - the axis and angle to be converted

### set

    public final void set(float scale)

  Sets the value of this matrix to a scale matrix with the passed scale amount.

  Parameters:
    `scale` - the scale factor for the matrix

### set

    public final void set(float[] m)

  Sets the values in this Matrix3f equal to the row-major array parameter (ie, the first four elements of the array will be copied into the first row of this matrix, etc.).

### set

    public final void set(Matrix3d m1)

  Sets the value of this matrix to the float value of the Matrix3d argument.

  Parameters:
    `m1` - the matrix3f

### set

    public final void set(Matrix3f m1)

  Sets the value of this matrix to the double value of the Matrix3f argument.

  Parameters:
    `m1` - the matrix3f

### set

    public final void set(Quat4d q1)

  Sets the value of this matrix to the matrix conversion of the (double precision) quaternion argument.

  Parameters:
    `q1` - the quaternion to be converted

### set

    public final void set(Quat4f q1)

  Sets the value of this matrix to the matrix conversion of the (single precision) quaternion argument.

  Parameters:
    `q1` - the quaternion to be converted

### setColumn

    public final void setColumn(int column,
                                float[] v)

  Sets the specified column of this matrix3d to the four values provided.

  Parameters:
    `column` - the column number to be modified (zero indexed)
    `v` - the replacement column

### setColumn

    public final void setColumn(int column,
                                float x,
                                float y,
                                float z)

  Sets the specified column of this matrix3d to the three values provided.

  Parameters:
    `column` - the column number to be modified (zero indexed)
    `x` - the first row element
    `y` - the second row element
    `z` - the third row element

### setColumn

    public final void setColumn(int column,
                                Vector3f v)

  Sets the specified column of this matrix3d to the vector provided.

  Parameters:
    `column` - the column number to be modified (zero indexed)
    `v` - the replacement column

### setElement

    public final void setElement(int row,
                                 int column,
                                 float value)

  Sets the specified element of this matrix3d to the value provided.

  Parameters:
    `row` - the row number to be modified (zero indexed)
    `column` - the column number to be modified (zero indexed)
    `value` - the new value

### setIdentity

    public final void setIdentity()

  Sets this Matrix3f to identity.

### setRow

    public final void setRow(int row,
                             float[] v)

  Sets the specified row of this matrix3d to the four values provided.

  Parameters:
    `row` - the row number to be modified (zero indexed)
    `v` - the replacement row

### setRow

    public final void setRow(int row,
                             float x,
                             float y,
                             float z)

  Sets the specified row of this matrix3d to the three values provided.

  Parameters:
    `row` - the row number to be modified (zero indexed)
    `x` - the first column element
    `y` - the second column element
    `z` - the third column element

### setRow

    public final void setRow(int row,
                             Vector3f v)

  Sets the specified row of this matrix3d to the Vector provided.

  Parameters:
    `row` - the row number to be modified (zero indexed)
    `v` - the replacement row

### setScale

    public final void setScale(float scale)

  Sets the scale component of the current matrix by factoring out the current scale (by doing an SVD) from the rotational component and multiplying by the new scale.

  Parameters:
    `scale` - the new scale amount

### setZero

    public final void setZero()

  Sets this matrix to all zeros.

### sub

    public final void sub(Matrix3f m1)

  Sets the value of this matrix to the matrix difference of itself and matrix m1 (this = this - m1).

  Parameters:
    `m1` - the other matrix

### sub

    public final void sub(Matrix3f m1,
                          Matrix3f m2)

  Sets the value of this matrix to the matrix difference of matrices m1 and m2.

  Parameters:
    `m1` - the first matrix
    `m2` - the second matrix

### toString

    public java.lang.String toString()

  Returns a string that contains the values of this Matrix3f.

  Overrides:
    `toString` in class `java.lang.Object`
  Returns:
    the String representation

### transform

    public final void transform(Tuple3f t)

  Transform the vector vec using this Matrix3f and place the result back into vec.

  Parameters:
    `vec` - the single precision vector to be transformed

### transform

    public final void transform(Tuple3f t,
                                Tuple3f result)

  Transform the vector vec using this Matrix3f and place the result into vecOut.

  Parameters:
    `result` - the vector into which the transformed values are placed

### transpose

    public final void transpose()

  Sets the value of this matrix to its transpose.

### transpose

    public final void transpose(Matrix3f m1)

  Sets the value of this matrix to the transpose of the argument matrix

  Parameters:
    `m1` - the matrix to be transposed

Overview | Package | Class | Tree | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD